#ifndef _MP_NUM_H
#define _MP_NUM_H

#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>

# ifndef WORD_SIZE
# define WORD_SIZE 2 /* nombre d'octet d'un mot de base ; 1, 2, 4 */
# endif

//extern int PREC;

#if (WORD_SIZE == 1) /* un octet dans un mot de base */
typedef uint8_t dig_t;
typedef uint16_t d_dig_t;

#define print_fmt "%hhu " /* macro utilisée pour afficher les mots de base */

#elif (WORD_SIZE == 2) /* deux octets dans un mot de base */
typedef uint16_t dig_t; /* type pour les "digits" du nombre */
typedef uint32_t d_dig_t; /* type double pour stocker les résultats d'addition, de multiplication, etc */
#define print_fmt "%hu " /* macro utilisée pour afficher les variables de type d_dig_t */

#else /* quatre octets dans un mot de base */
typedef uint32_t dig_t;
typedef uint64_t d_dig_t;
#define print_fmt "%u "

#endif /* WORD_SIZE */


/* structure pour nos entiers multi-précision */

typedef dig_t * number;

void init_mp_num ( unsigned int );

/* fonction d'initialisation : mise à zéro */
void reset_mp_num( number );

void set_mp_num( number dst, dig_t s );

/* allocation dynamique */
number  alloc_mp_num( void );

/* fonction d'arithmétique */
void add_mp_num( number , number , number );

/* fonctions diverses */
void print_mp_num( number );

#endif /* _MP_NUM_H */
